// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewListAppSecretsParams creates a new ListAppSecretsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewListAppSecretsParams() *ListAppSecretsParams {
	return &ListAppSecretsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewListAppSecretsParamsWithTimeout creates a new ListAppSecretsParams object
// with the ability to set a timeout on a request.
func NewListAppSecretsParamsWithTimeout(timeout time.Duration) *ListAppSecretsParams {
	return &ListAppSecretsParams{
		timeout: timeout,
	}
}

// NewListAppSecretsParamsWithContext creates a new ListAppSecretsParams object
// with the ability to set a context for a request.
func NewListAppSecretsParamsWithContext(ctx context.Context) *ListAppSecretsParams {
	return &ListAppSecretsParams{
		Context: ctx,
	}
}

// NewListAppSecretsParamsWithHTTPClient creates a new ListAppSecretsParams object
// with the ability to set a custom HTTPClient for a request.
func NewListAppSecretsParamsWithHTTPClient(client *http.Client) *ListAppSecretsParams {
	return &ListAppSecretsParams{
		HTTPClient: client,
	}
}

/*
ListAppSecretsParams contains all the parameters to send to the API endpoint

	for the list app secrets operation.

	Typically these are written to a http.Request.
*/
type ListAppSecretsParams struct {

	// AppName.
	AppName string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the list app secrets params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListAppSecretsParams) WithDefaults() *ListAppSecretsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the list app secrets params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListAppSecretsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the list app secrets params
func (o *ListAppSecretsParams) WithTimeout(timeout time.Duration) *ListAppSecretsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the list app secrets params
func (o *ListAppSecretsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the list app secrets params
func (o *ListAppSecretsParams) WithContext(ctx context.Context) *ListAppSecretsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the list app secrets params
func (o *ListAppSecretsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the list app secrets params
func (o *ListAppSecretsParams) WithHTTPClient(client *http.Client) *ListAppSecretsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the list app secrets params
func (o *ListAppSecretsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAppName adds the appName to the list app secrets params
func (o *ListAppSecretsParams) WithAppName(appName string) *ListAppSecretsParams {
	o.SetAppName(appName)
	return o
}

// SetAppName adds the appName to the list app secrets params
func (o *ListAppSecretsParams) SetAppName(appName string) {
	o.AppName = appName
}

// WithOrganizationID adds the organizationID to the list app secrets params
func (o *ListAppSecretsParams) WithOrganizationID(organizationID string) *ListAppSecretsParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the list app secrets params
func (o *ListAppSecretsParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the list app secrets params
func (o *ListAppSecretsParams) WithProjectID(projectID string) *ListAppSecretsParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the list app secrets params
func (o *ListAppSecretsParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *ListAppSecretsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param app_name
	if err := r.SetPathParam("app_name", o.AppName); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
