// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewListRotationIntegrationsParams creates a new ListRotationIntegrationsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewListRotationIntegrationsParams() *ListRotationIntegrationsParams {
	return &ListRotationIntegrationsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewListRotationIntegrationsParamsWithTimeout creates a new ListRotationIntegrationsParams object
// with the ability to set a timeout on a request.
func NewListRotationIntegrationsParamsWithTimeout(timeout time.Duration) *ListRotationIntegrationsParams {
	return &ListRotationIntegrationsParams{
		timeout: timeout,
	}
}

// NewListRotationIntegrationsParamsWithContext creates a new ListRotationIntegrationsParams object
// with the ability to set a context for a request.
func NewListRotationIntegrationsParamsWithContext(ctx context.Context) *ListRotationIntegrationsParams {
	return &ListRotationIntegrationsParams{
		Context: ctx,
	}
}

// NewListRotationIntegrationsParamsWithHTTPClient creates a new ListRotationIntegrationsParams object
// with the ability to set a custom HTTPClient for a request.
func NewListRotationIntegrationsParamsWithHTTPClient(client *http.Client) *ListRotationIntegrationsParams {
	return &ListRotationIntegrationsParams{
		HTTPClient: client,
	}
}

/*
ListRotationIntegrationsParams contains all the parameters to send to the API endpoint

	for the list rotation integrations operation.

	Typically these are written to a http.Request.
*/
type ListRotationIntegrationsParams struct {

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the list rotation integrations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListRotationIntegrationsParams) WithDefaults() *ListRotationIntegrationsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the list rotation integrations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListRotationIntegrationsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the list rotation integrations params
func (o *ListRotationIntegrationsParams) WithTimeout(timeout time.Duration) *ListRotationIntegrationsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the list rotation integrations params
func (o *ListRotationIntegrationsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the list rotation integrations params
func (o *ListRotationIntegrationsParams) WithContext(ctx context.Context) *ListRotationIntegrationsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the list rotation integrations params
func (o *ListRotationIntegrationsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the list rotation integrations params
func (o *ListRotationIntegrationsParams) WithHTTPClient(client *http.Client) *ListRotationIntegrationsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the list rotation integrations params
func (o *ListRotationIntegrationsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOrganizationID adds the organizationID to the list rotation integrations params
func (o *ListRotationIntegrationsParams) WithOrganizationID(organizationID string) *ListRotationIntegrationsParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the list rotation integrations params
func (o *ListRotationIntegrationsParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the list rotation integrations params
func (o *ListRotationIntegrationsParams) WithProjectID(projectID string) *ListRotationIntegrationsParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the list rotation integrations params
func (o *ListRotationIntegrationsParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *ListRotationIntegrationsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
