// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewListSyncIntegrationsParams creates a new ListSyncIntegrationsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewListSyncIntegrationsParams() *ListSyncIntegrationsParams {
	return &ListSyncIntegrationsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewListSyncIntegrationsParamsWithTimeout creates a new ListSyncIntegrationsParams object
// with the ability to set a timeout on a request.
func NewListSyncIntegrationsParamsWithTimeout(timeout time.Duration) *ListSyncIntegrationsParams {
	return &ListSyncIntegrationsParams{
		timeout: timeout,
	}
}

// NewListSyncIntegrationsParamsWithContext creates a new ListSyncIntegrationsParams object
// with the ability to set a context for a request.
func NewListSyncIntegrationsParamsWithContext(ctx context.Context) *ListSyncIntegrationsParams {
	return &ListSyncIntegrationsParams{
		Context: ctx,
	}
}

// NewListSyncIntegrationsParamsWithHTTPClient creates a new ListSyncIntegrationsParams object
// with the ability to set a custom HTTPClient for a request.
func NewListSyncIntegrationsParamsWithHTTPClient(client *http.Client) *ListSyncIntegrationsParams {
	return &ListSyncIntegrationsParams{
		HTTPClient: client,
	}
}

/*
ListSyncIntegrationsParams contains all the parameters to send to the API endpoint

	for the list sync integrations operation.

	Typically these are written to a http.Request.
*/
type ListSyncIntegrationsParams struct {

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the list sync integrations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListSyncIntegrationsParams) WithDefaults() *ListSyncIntegrationsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the list sync integrations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListSyncIntegrationsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the list sync integrations params
func (o *ListSyncIntegrationsParams) WithTimeout(timeout time.Duration) *ListSyncIntegrationsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the list sync integrations params
func (o *ListSyncIntegrationsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the list sync integrations params
func (o *ListSyncIntegrationsParams) WithContext(ctx context.Context) *ListSyncIntegrationsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the list sync integrations params
func (o *ListSyncIntegrationsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the list sync integrations params
func (o *ListSyncIntegrationsParams) WithHTTPClient(client *http.Client) *ListSyncIntegrationsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the list sync integrations params
func (o *ListSyncIntegrationsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOrganizationID adds the organizationID to the list sync integrations params
func (o *ListSyncIntegrationsParams) WithOrganizationID(organizationID string) *ListSyncIntegrationsParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the list sync integrations params
func (o *ListSyncIntegrationsParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the list sync integrations params
func (o *ListSyncIntegrationsParams) WithProjectID(projectID string) *ListSyncIntegrationsParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the list sync integrations params
func (o *ListSyncIntegrationsParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *ListSyncIntegrationsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
